-- Grims Clock is a simple clock to display real time on the game screen

-- Start with the standard imports
import "Turbine";
import "Turbine.UI";
import "Turbine.UI.Lotro";
import "Turbine.Gameplay";
-- Set our variables
varGC_Top=300; -- X position
varGC_Left=300; -- Y position
varGC_Opacity=.6; -- Opacity
varGC_NextTime = 0; -- used in update function
--
GrimsClockHUDState=true;
GrimsClockMainState=true;
GrimsClockMoveToggle=false;
localPlayer=Turbine.Gameplay.LocalPlayer:GetInstance();
--
-- Create a function to load our saved variables
LoadSettings=function()
	local settings=Turbine.PluginData.Load( Turbine.DataScope.Character, "GrimsClock_Settings");
	if settings~=nil then
		local tmpIndex;
		for tmpIndex=1,#settings do
			if settings[tmpIndex][1]=="Top" then
				varGC_Top=tonumber(settings[tmpIndex][2]);
			elseif settings[tmpIndex][1]=="Left" then
				varGC_Left=tonumber(settings[tmpIndex][2]);
			end
		end
	end
end
-- Run the function to load our saved variables
LoadSettings()
--
-- Lets create the window
winGrimsClock=class(Turbine.UI.Window);
--
function winGrimsClock:Constructor()
	Turbine.UI.Window.Constructor( self );
	self:SetSize(190,62);
	self:SetPosition(varGC_Left,varGC_Top);
	self:SetBackColor(Turbine.UI.Color(0,0,0,0)); -- a necessary evil since RoI for some reason. if we don't include this, the window doesn't redraw properly
	self:SetOpacity(varGC_Opacity);
-- Define the move panel - this is what shows up with CTRL+#
	self.MovePanel=Turbine.UI.Control();
	self.MovePanel:SetParent(self);
	self.MovePanel:SetSize(190,19);
	self.MovePanel:SetBackColor(Turbine.UI.Color(.5,0,0,0));
--
	self.Move=Turbine.UI.Control();
	self.Move:SetParent(self.MovePanel);
	self.Move:SetSize(19,19);
	self.Move:SetBackground("DaBruddasGrims/GrimsClock/Resources/picGC_Button.tga");
	self.Move:SetMouseVisible(false);
-- Define all the functions to make it movable
	self.MoveX=-1;
	self.MoveY=0;
	self.Moving=false;
--
	self.MovePanel.MouseDown=function()
	end
--
	self.MovePanel.MouseClick = function(sender,args)
		if self.Moving then
			self.Moving=false;
			self.MoveX=-1;
		end
	end
--
	self.MovePanel.MouseDown=function(sender,args)
		self.MoveX=args.X;
		self.MoveY=args.Y;
	end
--
	self.MovePanel.MouseUp=function(sender,args)
		self.MoveX=-1;
		self.MoveY=0;
	end
--
	self.MovePanel.MouseEnter=function(sender,args)
		self:SetOpacity(1);
	end
--
	self.MovePanel.MouseLeave=function(sender,args)
		self:SetOpacity(varGC_Opacity);
	end
--
	self.MovePanel.MouseMove=function(sender,args)
		if self.MoveX~=-1 and (args.X~=self.MoveX or args.Y~= self.MoveY) then
			self.Moving=true;
			local newLeft=self:GetLeft()-(self.MoveX-args.X)
			local newTop=self:GetTop()-(self.MoveY-args.Y)
			if newLeft<0 then newLeft=0 end;
			if newLeft>(Turbine.UI.Display.GetWidth()-self:GetWidth()) then newLeft=Turbine.UI.Display.GetWidth()-self:GetWidth() end;
			if newTop<0 then newTop=0 end;
			if newTop>(Turbine.UI.Display.GetHeight()-self:GetHeight()) then newTop=Turbine.UI.Display.GetHeight()-self:GetHeight() end;
			self:SetPosition(newLeft,newTop);
		end
	end

-- Defin4 all the bits that will be visible
	self.GrimsClockPanel=Turbine.UI.Control();
	self.GrimsClockPanel:SetParent(self);
	self.GrimsClockPanel:SetBackColor(Turbine.UI.Color(.3,0,0,0));
	self.GrimsClockPanel:SetPosition(20,0);
	self.GrimsClockPanel:SetSize(170,30);
--
	self.GCLeft=Turbine.UI.Control();
	self.GCLeft:SetParent(self.GrimsClockPanel);
	self.GCLeft:SetSize(35,42);
	self.GCLeft:SetPosition(0,-12);
	self.GCLeft:SetBackground("DaBruddasGrims/GrimsClock/Resources/picGC_Left.tga");
	self.GCLeft:SetMouseVisible(false);
	self.GCLeft:SetVisible(true);
	--
	self.GCMid=Turbine.UI.Control();
	self.GCMid:SetParent(self.GrimsClockPanel);
	self.GCMid:SetSize(100,42);
	self.GCMid:SetPosition(35,-12);
	self.GCMid:SetBackground("DaBruddasGrims/GrimsClock/Resources/picGC_Mid.tga");
	self.GCMid:SetMouseVisible(false);
	self.GCMid:SetVisible(true);
--	
	self.GCText=Turbine.UI.Label();
	self.GCText:SetParent(self.GCMid);
	self.GCText:SetSize(100,30);
	self.GCText:SetPosition(0,9);
	self.GCText:SetMultiline(false);
	self.GCText:SetFont(Turbine.UI.Lotro.Font.Verdana18);
	self.GCText:SetText("00:00:00");
	self.GCText:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	self.GCText:SetMouseVisible(false);
	self.GCText:SetVisible(true);
	self.GCText.HScrollBar=Turbine.UI.Lotro.ScrollBar();
	self.GCText.HScrollBar:SetOrientation(Turbine.UI.Orientation.Horizontal);
	self.GCText.HScrollBar:SetParent(self); -- see if the scrollbar will trigger "IsVisible()" even if it has no parent
	self.GCText.HScrollBar:SetHeight(12);
	self.GCText.HScrollBar:SetPosition(0,-13); -- position it off canvas so it won't ever actually display
	self.GCText:SetHorizontalScrollBar(self.GCText.HScrollBar);
--
	self.GCRight=Turbine.UI.Control();
	self.GCRight:SetParent(self.GrimsClockPanel);
	self.GCRight:SetSize(35,42);
	self.GCRight:SetPosition(135,-12);
	self.GCRight:SetBackground("DaBruddasGrims/GrimsClock/Resources/picGC_Right.tga");
	self.GCRight:SetMouseVisible(false);
	self.GCRight:SetVisible(true);
--
	self:SetMouseVisible(false);
--
	self.loaded=false;
	self:SetWantsUpdates(true);
	self:SetWantsKeyEvents(true);
	self.Changed=true;
-- This height function is to allow for DP on secondf line and can be removed
--	self.SetGrimsClockHeight=function()
--		self.GCLeft:SetVisible(true);
--		self.GCText:SetVisible(true);
--		self.GCRight:SetVisible(true);
--	end
--
-- This function updates the clock
	self.Update=function()
		local gameTime = Turbine.Engine.GetGameTime()
		local date = Turbine.Engine.GetDate()
		local stringtime = "00:00:00";
		local ampm = "am";
		hours, minutes, seconds = date.Hour, date.Minute, date.Second
		hours = string.format("%02d",hours);
		minutes = string.format("%02d",minutes);
		seconds = string.format("%02d",seconds);
		stringtime = hours..":"..minutes..":"..seconds;
		if gameTime >= varGC_NextTime then
			varGC_NextTime = Turbine.Engine.GetGameTime() + 1
			self.GCText:SetText(stringtime);
		end
		if not self.loaded then
			self.loaded=true;
			Plugins["GrimsClock"].Unload = function(self,sender,args)
				UnloadGrimsClock();
			end
			self:SetWantsUpdates(true);
		end
	end
--
	self.KeyDown=function(sender, args)
		if ( args.Action == 268435579 ) then -- reposition UI
			GrimsClockMoveToggle=not GrimsClockMoveToggle;
			GrimsClockWindow.MovePanel:SetVisible(GrimsClockMoveToggle);
		end
		if ( args.Action == 268435635 ) then -- toggle HUD
			GrimsClockHUDState = not GrimsClockHUDState;
			if GrimsClockHUDState then
				GrimsClockWindow:SetVisible(GrimsClockMainState);
			else
				GrimsClockMainState=GrimsClockWindow:IsVisible();
				GrimsClockWindow:SetVisible(false);
			end
		end
	end
--
	self.playerAttributes=localPlayer:GetAttributes();
--
--	self.SetGrimsClockHeight();
end

--
function UnloadGrimsClock()
	Turbine.Shell.WriteLine("GrimsClock "..Plugins["GrimsClock"]:GetVersion().." by Da Bruddas Grims unloaded");
	local Settings={};
	Settings[#Settings+1]={"Top",tostring(GrimsClockWindow:GetTop())};
	Settings[#Settings+1]={"Left",tostring(GrimsClockWindow:GetLeft())};
	Turbine.PluginData.Save( Turbine.DataScope.Character, "GrimsClock_Settings", Settings );
end
--
GrimsClockWindow=winGrimsClock()
GrimsClockWindow:SetVisible(true);
GrimsClockWindow.MovePanel:SetVisible(false);